init_setup;
INPUT_DIR = [RESULTS_DIR 'NYU/20150416T231127/'];

if ~exist('images','var')
    load([DATA_DIR 'NYU/splits_nyu.mat']);
    load([DATA_DIR 'NYU/nyu_depth_v2_labeled.mat']);
    gt_depths = depths;
end

%%
load([DATA_DIR 'eigen/predictions_depth.mat']);
predicted_mask = imresize(predicted_mask,2,'nearest');
idx = testNdxs;

mse = cell(2,1);
lsi = cell(2,1);
%%
for t=1:2
    mse{t} = zeros(length(idx),1);
    mselog{t} = zeros(length(idx),1);
    lsi{t} = zeros(length(idx),1);
    absrel{t} = zeros(length(idx),1);
    sqrrel{t} = zeros(length(idx),1);
end

frmse = @(z,gtz) sqrt(mean((z(:)-gtz(:)).^2));
frmselog = @(z,gtz) sqrt(mean((log(z(:)) - log(gtz(:))).^2));
flsi = @(z,gtz) 0.5*mean( ( log(z(:))-log(gtz(:)) + (mean(log(z(:)))-mean(log(gtz(:)))) ).^2);
fabsrel = @(z,gtz) mean(abs(z(:)-gtz(:))./gtz(:));
fsqrrel = @(z,gtz) mean((z(:)-gtz(:)).^2./gtz(:));
meanZ = mean(mean2(gt_depths(:,:,trainNdxs)));
for i=1:length(idx)
    fprintf('%d of %d\n',i,length(idx));
    
    I = images(:,:,:,idx(i));

    gtZ = gt_depths(:,:,idx(i));
    
    t=1;
    
    load(sprintf([INPUT_DIR 'ROI_ls_%d.mat'],i),'data');
    Z = data.Z;
    crop = data.opts.crop_region;
    gtZ = gtZ(crop:end-crop,crop:end-crop);

    mse{t}(i) = mse(Z,gtZ);
    mselog{t}(i) = mselog(Z,gtZ);
    lsi{t}(i) = flsi(Z,gtZ);
    absrel{t}(i) = fabsrel(Z,gtZ);
    sqrrel{t}(i) = fsqrrel(Z,gtZ);
    
    t=t+1;
    eigen_Z = imresize(depths(:,:,i),2,'bilinear');
    eigen_Z = eigen_Z(crop:end-crop,crop:end-crop);
    
    mse{t}(i) = fmse(eigen_Z,gtZ);
    mselog{t}(i) = mselog(eigen_Z,gtZ);
    lsi{t}(i) = flsi(eigen_Z,gtZ);
    absrel{t}(i) = fabsrel(eigen_Z,gtZ);
    sqrrel{t}(i) = fsqrrel(eigen_Z,gtZ);
    
%     subplot(2,2,1); showim(gtZ); title('gt');
%     subplot(2,2,2); showim(Z); title('ours');
%     subplot(2,2,3); showim(eigen_Z); title('eigen');
%     drawnow;
%     keyboard;
end
%%
sqrt(mean(mse{1}))
sqrt(mean(mse{2}))
%%
sqrt(mean(mselog{1}))
sqrt(mean(mselog{2}))
%%
mean(absrel{1})
mean(absrel{2})
%%
mean(sqrrel{1})
mean(sqrrel{2})

%%
mean(lsi{1})
mean(lsi{2})