opts = get_default_opts();

opts.relation_field = 'closer';
opts.relation_field_score = 'closer_score';


% key point params
opts.kp_params.min_sep = 0.03;
opts.kp_params.use_multiscale = true;

% ROI params
params_ROI = [];
params_ROI.N = 8; % half patch size
params_ROI.mask_size = 32; % mask size for each blob (location of patch within the ROI) and ROI
params_ROI.blob_std = 0.1; % blob standard deviation
params_ROI.ROI_size = params_ROI.mask_size; % size of ROI 
params_ROI.I_size = 64;
params_ROI.BB_size = 32;
opts.params_ROI = params_ROI;

% DNN params
opts.DNN.model_def_file = './Models/NYU/ROI_ms_raw/deploy.prototxt';
opts.DNN.model_file = './Models/NYU/ROI_ms_raw/depth_net_ms_raw_iter_132000.caffemodel';
% opts.DNN.model_def_file = './Models/NYU/ROI_ms/deploy.prototxt';
% opts.DNN.model_file = './Models/NYU/ROI_ms/depth_net_ms_iter_400000.caffemodel';
% opts.DNN.model_def_file = './Models/NYU/ROI_new_simple/deploy.prototxt';
% opts.DNN.model_file = './Models/NYU/ROI_new_simple/depth_net_iter_400000.caffemodel';
% opts.DNN.model_def_file = './Models/NYU/ROI_simple_raw/deploy.prototxt';
% opts.DNN.model_file = './Models/NYU/ROI_simple_raw/depth_net_iter_400000.caffemodel';


opts.DNN.which_layer = 'prob';
opts.DNN.Nbatch = 512;

% LS ranking params
ls_ranking_params = [];
ls_ranking_params.use_all_preds = true;
ls_ranking_params.use_uniform_weights = false;
ls_ranking_params.upper_bound = 10;
ls_ranking_params.lower_bound = 0;

ls_ranking_params.ie_weight = 1;
ls_ranking_params.eq_weight = 2;
ls_ranking_params.ie_ratio = -1;
ls_ranking_params.prior_weight = 20;

opts.ls_ranking_params = ls_ranking_params;

opts.depth_params.image_smoothness_var = 0.07; % make it less than 0.1 to make result really sharp

opts.ls_ranking_params.solve_with_ratio = true;
opts.ls_ranking_params.ratio_solver_ie_var = 16;
opts.ls_ranking_params.ratio_solver_eq_var = 0.1;

opts.crop_region = 16;

if ~exist('images','var')
    load([DATA_DIR 'NYU/nyu_depth_v2_labeled.mat']);
end

load([DATA_DIR 'NYU/splits_nyu.mat']);
idx = testNdxs;

points_outputs = cell(length(idx),1);
comps_outputs = cell(length(idx),1);
OUT_DIR = [RESULTS_DIR 'NYU/' datestr(now(),30) '/'];
if ~exist(OUT_DIR,'dir')
    mkdir(OUT_DIR);
end
%%
r = opts.crop_region;
for i=1:length(idx)
    out_name = sprintf([OUT_DIR 'ROI_ls_%d.mat'],i);
    
    if (exist(out_name,'file'))
        continue;
    else
        fprintf('processing image %s',out_name);
    end
    
    %%
    I = images(:,:,:,idx(i));
    I = I(r:end-r,r:end-r,:);
    %%
    tic
    [Z,points_outputs,comps_outputs] = do_depth_from_image(I,opts);
    toc
      
    %save([OUT_DIR 'ROI_ls.mat'],'depth_outputs','points_outputs','comps_outputs','opts');
    data = [];
    data.Z = Z;
    data.points_outputs = points_outputs;
    data.comps_outputs = comps_outputs;
    data.opts = opts;
    parsave(out_name,data);
    
%     subplot(2,1,1); showim(I);
%     subplot(2,1,2); showim(Z); colormap jet;

%     drawnow;
end
