function [create_cmd] = convert_to_lmdb(A,C,FIELD_NAME,DATASET,DB_NAME)
    
    globals;
    
    TOOLS_DIR = fullfile(CAFFE_DIR,'build','tools');
    DB_DATA_DIR = fullfile(DATA_DIR,DATASET,DB_NAME);
    LISTFILE_A = fullfile(DB_DATA_DIR,FIELD_NAME,'listfile.txt');
    
    % write all files
    if (~exist(DB_DATA_DIR,'dir'))
        mkdir(DB_DATA_DIR);
    end
    if ~exist(fullfile(DB_DATA_DIR,FIELD_NAME),'dir')
        mkdir(fullfile(DB_DATA_DIR,FIELD_NAME));
    end
    DB_DATA_DIR = expand_full_path(DB_DATA_DIR);   
    
    fid_A = fopen(LISTFILE_A,'w');
    for i=1:length(C)
        fprintf('Writing image %d\n',i);
        
        curr_A_name = fullfile(DB_DATA_DIR,FIELD_NAME,sprintf('%d.jpg',i));
        
        imwrite(A(:,:,:,i),curr_A_name);
        if size(C,1)>1
            c_str = mat2str(C(:,i)'); c_str = c_str(2:end-1);
        else
            c_str = num2str(C(i));
        end
        fprintf(fid_A,[curr_A_name ' ' c_str  '\n']);
    end
    fclose(fid_A);
    
    create_cmd = fullfile(TOOLS_DIR,sprintf('convert_imageset.bin %s %s %s','/',LISTFILE_A,fullfile(DB_DATA_DIR,['lmdb_' FIELD_NAME])));

