function [test_data,train_data] = generate_bsds_data_new(opts)

% read in the BSDS figure-ground data and put in into the test_data
% and train_data structures, which contain, an image id, a segmentation
% and a figure-ground segmentation

% get names of test and training images
DATA_DIR = opts.paths.DATA_DIR;
test_list = dir([DATA_DIR 'BSDS500/groundtruth/testfg/*.mat']);
train_list = dir([DATA_DIR 'BSDS500/groundtruth/trainfg/*.mat']);

% now read in the data
test_cnt = 1;
train_cnt = 1;
test_data = {};
train_data = {};

for i=1:length(test_list)
    [~,img_id,~] = fileparts(test_list(i).name);
    % two annotations per image
    data = load([DATA_DIR 'BSDS500/groundtruth/testfg/' img_id '.mat']);
    test_data{test_cnt}.image = imread([DATA_DIR 'BSDS500/images/train/' img_id '.jpg']);
    test_data{test_cnt}.seg = data.gt.groundTruth.Segmentation;
    test_data{test_cnt}.fgmap = data.gt.groundTruth.fg{1}{1};
    test_data{test_cnt}.name = img_id;
    test_cnt = test_cnt + 1;
    
    test_data{test_cnt}.image = imread([DATA_DIR 'BSDS500/images/train/' img_id '.jpg']);
    test_data{test_cnt}.seg = data.gt.groundTruth.Segmentation;
    test_data{test_cnt}.fgmap = data.gt.groundTruth.fg{2}{1};
    test_data{test_cnt}.name = img_id;
    test_cnt = test_cnt + 1;
end

for i=1:length(train_list)
    [~,img_id,~] = fileparts(train_list(i).name);
    % two annotations per image
    data = load([DATA_DIR 'BSDS500/groundtruth/trainfg/' img_id '.mat']);
    train_data{train_cnt}.image = imread([DATA_DIR 'BSDS500/images/train/' img_id '.jpg']);
    train_data{train_cnt}.seg = data.gt.groundTruth.Segmentation;
    train_data{train_cnt}.fgmap = data.gt.groundTruth.fg{1}{1};
    train_data{train_cnt}.name = img_id;
    train_cnt = train_cnt + 1;
    
    train_data{train_cnt}.image = imread([DATA_DIR 'BSDS500/images/train/' img_id '.jpg']);
    train_data{train_cnt}.seg = data.gt.groundTruth.Segmentation;
    train_data{train_cnt}.fgmap = data.gt.groundTruth.fg{2}{1};
    train_data{train_cnt}.name = img_id;
    train_cnt = train_cnt + 1;
end

