opts = get_default_opts();

opts.MIT_gen.train = 1;
opts.MIT_gen.data_set = 'MIT/ROI_ms_depth';
opts.MIT_gen.annotations_dir = 'MIT_annotations_simple_ms/';
opts.MIT_gen.closer_field = 'closer';
opts.MIT_gen.closer_score_field = 'closer_score';

opts.MIT_gen.comps_per_image = 800; % set -1 to use all

% parameters for extraction
params = [];
params.N = 8; % half patch size
params.mask_size = 32; % mask size for each blob (location of patch within the ROI) and ROI
params.blob_std = 0.1; % blob standard deviation
params.ROI_size = params.mask_size; % size of ROI 
params.BB_size = 32; % size of bounding box
params.I_size = 64; % size of downscaled images

opts.params_ROI = params;

disp('generating ROI data');
disp(opts.MIT_gen);
    
generate_MIT_ROI_for_dnn(opts);
