opts = get_default_opts();

opts.bsds_gen.train = 0;
opts.bsds_gen.data_set = 'BSDS/ROI_ms';
opts.bsds_gen.annotations_dir = 'bsds_annotations_simple_ms/';
opts.bsds_gen.closer_field = 'closer';
opts.bsds_gen.closer_score_field = 'closer_score';

opts.bsds_gen.comps_per_image = 800; % set -1 to use all

% parameters for extraction
params = [];
params.N = 8; % half patch size
params.mask_size = 32; % mask size for each blob (location of patch within the ROI) and ROI
params.blob_std = 0.1; % blob standard deviation
params.ROI_size = params.mask_size; % size of ROI 
params.BB_size = 32; % size of bounding box
params.I_size = 64; % size of downscaled images

opts.params_ROI = params;

disp('generating ROI data');
disp(opts.bsds_gen);
    
generate_bsds_ROI_for_dnn(opts);
