opts = get_default_opts();

opts.NYU_gen.train = 1;
opts.NYU_gen.data_set = 'NYU/ROI_rand_raw';
opts.NYU_gen.annotations_dir = 'nyu_annotations_simple_rand/';
opts.NYU_gen.closer_field = 'closer_raw';
opts.NYU_gen.closer_score_field = 'closer_score_raw';

opts.NYU_gen.comps_per_image = 800; % set -1 to use all

% parameters for extraction
params = [];
params.N = 8; % half patch size
params.mask_size = 32; % mask size for each blob (location of patch within the ROI) and ROI
params.blob_std = 0.1; % blob standard deviation
params.ROI_size = params.mask_size; % size of ROI 
params.BB_size = 32; % size of bounding box
params.I_size = 64; % size of downscaled images

opts.params_ROI = params;
disp('generating ROI data');
disp(opts.NYU_gen);

generate_nyu_ROI_for_dnn(opts);
