function [points,sp_data] = extract_key_points(I,params)
points = [];

if isfield(params,'min_sep')
    min_sep = params.min_sep;
else
    min_sep = 0.05;
end

if isfield(params,'reg')
    reg = params.reg;
else
    reg = 0.05;
end

if isfield(params,'pixel_neighbors')
    pixel_neighbors = params.pixel_neighbors;
    r = params.r;
else
    pixel_neighbors = 0;
    r = 1;
end

% extract superpixels
%     II = cat(3,reshape(L,size(logL)),reshape(C1,size(logL)),reshape(C2,size(logL)));
segs = vl_slic(im2single(I),min_sep*max(size(I,1),size(I,2)),reg);
segs = segs+1;
nsegs = max(segs(:));
npoints = nsegs;

[sp_data] = extractSuperpixelNeighborhood(segs,pixel_neighbors,r);

% get points to compare 
for i=1:npoints
    ind = i;
    points(ind).id = ind;
    
    cx = median(sp_data.xs{i});
    cy = median(sp_data.ys{i});
    points(ind).x = cx/size(I,2);
    points(ind).y = cy/size(I,1);
    points(ind).j = round(cx);
    points(ind).i = round(cy);
    points(ind).ind = sub2ind(size(I),points(i).i, points(i).j);
    points(ind).opaque = 1;
    
    if isempty(sp_data.spidx{i})
        points(ind).opaque = 0;
    end
end

sp_data.npoints = npoints;
sp_data.nsegs = nsegs;
sp_data.segs = segs;