function [preds,f] = infer_ordinal_relations_MS(I,points,comps,opts)
    [BB,M] = extract_bb_ms_from_comps(I,points,comps,opts);
    
    batch_size = 64;
    num_samples = size(M{1},4);
    num_batches = ceil(num_samples/batch_size);
    f = zeros(3,num_samples);
    
    for i=1:num_batches
        fprintf('batch %d of %d\n',i,num_batches);
        inds = (1+(i-1)*batch_size):(i*batch_size);
        inds(inds>num_samples) = [];
        inputs(1).name = 'BB_data_1';
        inputs(1).x = gpuArray(im2single(BB{1}(:,:,:,inds)));
        inputs(2).name = 'M_data_1';
        inputs(2).x = gpuArray(im2single(M{1}(:,:,1:2,inds)));
        inputs(3).name = 'BB_data_3';
        inputs(3).x = gpuArray(im2single(BB{3}(:,:,:,inds)));
        inputs(4).name = 'M_data_3';
        inputs(4).x = gpuArray(im2single(M{3}(:,:,1:2,inds)));
        inputs(5).name = 'BB_data_5';
        inputs(5).x = gpuArray(im2single(BB{5}(:,:,:,inds)));
        inputs(6).name = 'M_data_5';
        inputs(6).x = gpuArray(im2single(M{5}(:,:,1:2,inds)));
        inputs(7).name = 'BB_data_4';
        inputs(7).x = gpuArray(im2single(BB{4}(:,:,:,inds)));
        inputs(8).name = 'M_data_4';
        inputs(8).x = gpuArray(im2single(M{4}(:,:,1:2,inds)));
        inputs(9).name = 'BB_data_2';
        inputs(9).x = gpuArray(im2single(BB{2}(:,:,:,inds)));
        inputs(10).name = 'M_data_2';
        inputs(10).x = gpuArray(im2single(M{2}(:,:,1:2,inds)));
        
        res = vl_dagnn(opts.net,inputs,[],[],[],'disableDropout',true);
        
        out = squeeze(gather(res(end).x));
        f(:,inds) = out;
    end
%     f = exp(f); f = bsxfun(@times,f,1./sum(f,1));
    [~,preds] = max(f,[],1); preds = preds-1;
    reset(gpuDevice(1));
end