function [preds,f] = infer_ordinal_relations_conv(I,points,comps,opts)
    
    p1s = [comps.point1];
    p2s = [comps.point2];
    i1 = [points(p1s).i]/size(I,1);
    j1 = [points(p1s).j]/size(I,2);

    i2 = [points(p2s).i]/size(I,1);
    j2 = [points(p2s).j]/size(I,2);
    
    coords = [i1(:)';j1(:)';i2(:)';j2(:)'];
    
    last_layer = 16; %12
    I_net = opts.net;
    I_net.layers(last_layer:end) = [];% = opts.net.layers(1:15};
    inputs = [];
    inputs(1).name = 'input_image';
    inputs(1).x = gpuArray(im2single(I));
    
    res_I = vl_dagnn(I_net,inputs,[],[],[],'disableDropout',true);
    
    batch_size = 64;
    num_samples = size(coords,2);
    num_batches = ceil(num_samples/batch_size);
    f = zeros(3,num_samples);
    
    FC_net = opts.net;
    FC_net.layers(1:last_layer-1) = [];
    for i=1:num_batches
        fprintf('batch %d of %d\n',i,num_batches);
        inds = (1+(i-1)*batch_size):(i*batch_size);
        inds(inds>num_samples) = [];
        inputs = [];
    
        inputs(1).name = 'pool1';
        inputs(1).x = repmat(res_I(4).x,[1 1 1 length(inds)]);
        inputs(2).name = 'pool2';
        inputs(2).x = repmat(res_I(8).x,[1 1 1 length(inds)]);
        inputs(3).name = 'pool5';
        inputs(3).x = repmat(res_I(last_layer).x,[1 1 1 length(inds)]);

    
        inputs(4).name = 'coords';
        inputs(4).x = gpuArray(single(coords(:,inds)));
        res = vl_dagnn(FC_net,inputs,[],[],[],'disableDropout',true);
        
        out = squeeze(gather(res(end).x));
        f(:,inds) = out;
    end

    [~,preds] = max(f,[],1); preds = preds-1;
    reset(gpuDevice(1));
end