init_setup;
INPUT_DIR = [RESULTS_DIR 'NYU/20150419T164154/'];

if ~exist('images','var')
    load([DATA_DIR 'NYU/splits_nyu.mat']);
    load([DATA_DIR 'NYU/nyu_depth_v2_labeled.mat']);
    gt_depths = depths;
end

%%
load([DATA_DIR 'eigen/predictions_depth.mat']);
predicted_mask = imresize(predicted_mask,2,'nearest');
idx = testNdxs;

mse = cell(2,1);
lsi = cell(2,1);

i = 472;

frmse = @(z,gtz) sqrt(mean((z(:)-gtz(:)).^2));
frmselog = @(z,gtz) sqrt(mean((log(z(:)) - log(gtz(:))).^2));
flsi = @(z,gtz) 0.5*mean( ( log(z(:))-log(gtz(:)) + (mean(log(z(:)))-mean(log(gtz(:)))) ).^2);
fabsrel = @(z,gtz) mean(abs(z(:)-gtz(:))./gtz(:));
fsqrrel = @(z,gtz) mean((z(:)-gtz(:)).^2./gtz(:));


fprintf('%d of %d\n',i,length(idx));

I = images(:,:,:,idx(i));

gtZ = gt_depths(:,:,idx(i));


load(sprintf([INPUT_DIR 'ROI_ls_%d.mat'],i),'data');
Z = data.Z;
crop = data.opts.crop_region;
gtZ = gtZ(crop:end-crop,crop:end-crop);


eigen_Z = imresize(depths(:,:,i),2,'bilinear');
eigen_Z = eigen_Z(crop:end-crop,crop:end-crop);


subplot(2,2,1); showim(I(crop:end-crop,crop:end-crop,:));
subplot(2,2,2); showim(Z);
subplot(2,2,3); showim(gtZ);
subplot(2,2,4); showim(eigen_Z);
%%
imwrite(I,sprintf('../Paper/figure/nyu/%d_I.png',i));
imwrite(mat2gray(Z),sprintf('../Paper/figure/nyu/%d_Z.png',i));
imwrite(mat2gray(eigen_Z),sprintf('../Paper/figure/nyu/%d_eigen.png',i));
imwrite(mat2gray(gtZ),sprintf('../Paper/figure/nyu/%d_gt.png',i));