I = imread('141.png');
filename = '141';

% make sure piotr dollar's toolbox and vlfeat are in the path
init_setup

opts.relation_field = 'darker';
opts.relation_field_score = 'darker_score';

% key point params
opts.kp_params.min_sep = 0.03;
opts.kp_params.use_multiscale = true;

% ROI params
params_ROI = [];
params_ROI.N = 8; % half patch size
params_ROI.mask_size = 32; % mask size for each blob (location of patch within the ROI) and ROI
params_ROI.blob_std = 0.1; % blob standard deviation
params_ROI.ROI_size = params_ROI.mask_size; % size of ROI 
params_ROI.I_size = 64;
params_ROI.BB_size = 32;
opts.params_ROI = params_ROI;

% DNN params
opts.DNN.model_def_file = './Models/NYU/ROI_ms_raw/deploy_fast.prototxt';
opts.DNN.model_def_file_I = './Models/NYU/ROI_ms_raw/deploy_I.prototxt';
opts.DNN.model_file = './Models/IIW/ROI_smaller/reflectance_net_iter_400000.caffemodel';
opts.DNN.which_layer = 'prob';
opts.DNN.which_layer_I = 'norm2_I';
opts.DNN.Nbatch = 512;

% LS ranking params
ls_ranking_params = [];
ls_ranking_params.use_all_preds = true;
ls_ranking_params.use_uniform_weights = false;
ls_ranking_params.upper_bound = 0;
ls_ranking_params.lower_bound = log(1/255);

ls_ranking_params.ie_weight = 1;
ls_ranking_params.eq_weight = 5;
ls_ranking_params.ie_ratio = -log(2);
ls_ranking_params.prior_weight = 0.5;
ls_ranking_params.score_threshold = 0.2;

opts.ls_ranking_params = ls_ranking_params;

opts.ls_ranking_params.solve_with_ratio = false;
opts.ls_ranking_params.ratio_solver_ie_var = 1.5;
opts.ls_ranking_params.ratio_solver_eq_var = 0.1;

opts.intrinsic.blur_output = false;

opts.viz = false;
%%
tic
[R,S,points,comps] = do_intrinsic_decomposition(I,opts);
toc

%%

subplot(2,2,1); showim(I); title('image');
subplot(2,2,2); showim(R); title('reflectance');


tt = im2double(I);
RR = R;
SS = mean(tt,3)./vl_imsmooth(R,1);
RR = RR-min(RR(:)); RR = RR./max(RR(:));
RR = bsxfun(@times,bsxfun(@times,tt,1./mean(tt,3)),RR); RR(RR<0) = 0; RR(RR>1) =1;
subplot(2,2,3); showim(SS); title('shading');
subplot(2,2,2); showim(RR);
%%
subplot(2,2,4); show_annotations(I,points,comps);
%%
load(sprintf('%s_comps.mat',filename),'comps');
load(sprintf('%s_points.mat',filename),'points');

WHDR(R,points,comps,0.1)
filename
% 
% figure;
% S = SS;
% % RR = RR - min(RR(:)); RR = RR./max(RR(:));
%  RR = RR./max(RR(:));
% t = im2double(I);
% subplot(2,2,1); showim(RR); title('R');
% SS = mean(t,3)./(RR); SS(SS<0) = 0; SS(SS>1.4) = 1.4; SS = mat2gray(SS);
% % SS = SS-min(SS(:)); SS = SS./max(SS(:));
% subplot(2,2,2); showim(SS); title('SS');
% subplot(2,2,3); showim(S); title('S');
% R_color = bsxfun(@times,bsxfun(@times,t,1./mean(t,3)),RR); R_color(R_color<0) = 0; R_color(R_color>1) = 1;
% subplot(2,2,4); showim(R_color); title('R_color');