% function train_selection_net()
init_setup

run('./matconvnet_dag/matlab/vl_setupnn.m') ;
addpath(['./matconvnet_dag/examples'])
addpath(['./matconvnet_dag/'])

% initialize net
net = init_selection_net();

if ~exist('imdb','var')
    opts = get_default_opts();
    
    opts.bsds_gen.annotations_dir = 'bsds_annotations_simple_ms/';
    opts.bsds_gen.closer_field = 'closer';
    opts.bsds_gen.closer_score_field = 'closer_score';

    opts.bsds_gen.comps_per_image = 800; % set -1 to use all
    
    imdb = load_bsds_imdb(opts);
end
%%
outputDefs = [];
outputDefs(1).name = 'objective';
outputDefs(1).layerName = 'loss';
outputDefs(1).printfun = @(x) fprintf(1,'objective is %f\n',x);

[net, info] = cnn_dagtrain(net, imdb, @getBatch_selection,outputDefs,...
                        'useGpu',true,'batchSize',32,'learningRate',logspace(-3, -6, 30),...
                    'expDir', fullfile('data','conv_ord_bsds_slow'));


