% function train_selection_net()
init_setup

run('./matconvnet_dag/matlab/vl_setupnn.m') ;
addpath(['./matconvnet_dag/examples'])
addpath(['./matconvnet_dag/'])

% initialize net
net = init_selection_net();

if ~exist('imdb','var')
    opts = get_default_opts();
    
    opts.NYU_gen.train = 0;
    opts.NYU_gen.annotations_dir = 'nyu_annotations_simple_ms/';
    opts.NYU_gen.closer_field = 'closer_raw';
    opts.NYU_gen.closer_score_field = 'closer_score_raw';

    opts.NYU_gen.comps_per_image = 800; % set -1 to use all
    
    imdb = load_nyu_imdb(opts);
end
%%
outputDefs = [];
outputDefs(1).name = 'objective';
outputDefs(1).layerName = 'loss';
outputDefs(1).printfun = @(x) fprintf(1,'objective is %f\n',x);

[net, info] = cnn_dagtrain(net, imdb, @getBatch_selection,outputDefs,...
                        'useGpu',true,'batchSize',32,'learningRate',logspace(-2, -4, 30),...
                    'expDir', fullfile('data','conv_ord2'));


